/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.alibaba.fastjson2.JSONObject
 *  com.github.pagehelper.PageInfo
 *  com.ruoyi.common.core.utils.StringUtils
 *  com.ruoyi.common.core.utils.bean.BeanUtils
 *  com.ruoyi.common.core.utils.poi.ExcelUtil
 *  com.ruoyi.common.core.web.controller.BaseController
 *  com.ruoyi.common.core.web.domain.AjaxResult
 *  com.ruoyi.common.core.web.page.TableDataInfo
 *  com.ruoyi.common.log.annotation.Log
 *  com.ruoyi.common.log.enums.BusinessType
 *  com.ruoyi.common.security.annotation.RequiresPermissions
 *  com.ruoyi.system.controller.SnServerController
 *  com.ruoyi.system.domain.SnServer
 *  com.ruoyi.system.domain.dto.DeploySSLParams
 *  com.ruoyi.system.domain.dto.DockerLogsParams
 *  com.ruoyi.system.domain.dto.SnServerDto
 *  com.ruoyi.system.domain.dto.UpdateBaseParams
 *  com.ruoyi.system.service.ISnServerService
 *  javax.servlet.http.HttpServletResponse
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.web.bind.annotation.DeleteMapping
 *  org.springframework.web.bind.annotation.GetMapping
 *  org.springframework.web.bind.annotation.PathVariable
 *  org.springframework.web.bind.annotation.PostMapping
 *  org.springframework.web.bind.annotation.PutMapping
 *  org.springframework.web.bind.annotation.RequestBody
 *  org.springframework.web.bind.annotation.RequestMapping
 *  org.springframework.web.bind.annotation.RestController
 */
package com.ruoyi.system.controller;

import com.alibaba.fastjson2.JSONObject;
import com.github.pagehelper.PageInfo;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.core.utils.bean.BeanUtils;
import com.ruoyi.common.core.utils.poi.ExcelUtil;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.ruoyi.system.domain.SnServer;
import com.ruoyi.system.domain.dto.DeploySSLParams;
import com.ruoyi.system.domain.dto.DockerLogsParams;
import com.ruoyi.system.domain.dto.SnServerDto;
import com.ruoyi.system.domain.dto.UpdateBaseParams;
import com.ruoyi.system.service.ISnServerService;
import java.util.ArrayList;
import java.util.List;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(value={"/SnServer"})
public class SnServerController
extends BaseController {
    @Autowired
    private ISnServerService snServerService;

    @RequiresPermissions(value={"system:SnServer:list"})
    @GetMapping(value={"/list"})
    public TableDataInfo list(SnServer snServer) {
        this.startPage();
        List list = this.snServerService.selectSnServerList(snServer);
        TableDataInfo rspData = new TableDataInfo();
        rspData.setCode(200);
        rspData.setRows(BeanUtils.copyList((List)list, SnServerDto.class));
        rspData.setMsg("查询成功");
        rspData.setTotal(new PageInfo(list).getTotal());
        return rspData;
    }

    @RequiresPermissions(value={"system:SnServer:export"})
    @Log(title="服务器", businessType=BusinessType.EXPORT)
    @PostMapping(value={"/export"})
    public void export(HttpServletResponse response, SnServer snServer) {
        List list = this.snServerService.selectSnServerList(snServer);
        ExcelUtil util = new ExcelUtil(SnServerDto.class);
        util.exportExcel(response, BeanUtils.copyList((List)list, SnServerDto.class), "服务器列表数据");
    }

    @RequiresPermissions(value={"system:SnServer:query"})
    @GetMapping(value={"/{serverId}"})
    public AjaxResult getInfo(@PathVariable(value="serverId") Long serverId) {
        return this.success(BeanUtils.copy((Object)this.snServerService.selectSnServerByServerId(serverId), SnServerDto.class));
    }

    @RequiresPermissions(value={"system:SnServer:add"})
    @Log(title="服务器", businessType=BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody SnServer snServer) {
        return this.snServerService.insertSnServer(snServer);
    }

    @RequiresPermissions(value={"system:SnServer:edit"})
    @Log(title="服务器", businessType=BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody SnServer snServer) {
        return this.toAjax(this.snServerService.updateSnServer(snServer));
    }

    @RequiresPermissions(value={"system:SnServer:remove"})
    @Log(title="服务器", businessType=BusinessType.DELETE)
    @DeleteMapping(value={"/{serverIds}"})
    public AjaxResult remove(@PathVariable Long[] serverIds) {
        if (serverIds.length > 1) {
            return AjaxResult.error((String)"服务器只能单个删除");
        }
        return this.toAjax(this.snServerService.deleteSnServerByServerIds(serverIds));
    }

    @RequiresPermissions(value={"system:SnServer:deployBasic"})
    @Log(title="部署服务器基础环境", businessType=BusinessType.OTHER)
    @PostMapping(value={"/deployBasicEnv"})
    public AjaxResult deployBasicEnv(@RequestBody SnServer snServer) {
        if (StringUtils.isEmpty((String)snServer.getDomain())) {
            return this.error("请先填写域名");
        }
        if (snServer.getServerId() == null) {
            return this.error("服务器ID不能为空");
        }
        return this.snServerService.deployBasicEnv(snServer);
    }

    @RequiresPermissions(value={"system:SnServer:changeDomain"})
    @Log(title="更换基础环境域名", businessType=BusinessType.OTHER)
    @PostMapping(value={"/changeDomain"})
    public AjaxResult changeDomain(@RequestBody SnServer snServer) {
        if (StringUtils.isEmpty((String)snServer.getDomain())) {
            return this.error("请先填写域名");
        }
        if (snServer.getServerId() == null) {
            return this.error("服务器ID不能为空");
        }
        return this.snServerService.changeDomain(snServer);
    }

    @RequiresPermissions(value={"system:SnServer:deployDomainSSL"})
    @Log(title="部署基础环境ssl证书", businessType=BusinessType.OTHER)
    @PostMapping(value={"/deployDomainSSL"})
    public AjaxResult deployDomainSSL(@RequestBody DeploySSLParams params) {
        if (params.getId() == null) {
            return this.error("服务器ID不能为空");
        }
        if (params.getType() == null) {
            return this.error("证书类型不能为空");
        }
        if (params.getType() != 1 && params.getType() != 2) {
            return this.error("证书类型有误");
        }
        if (params.getType() == 2 && StringUtils.isEmpty((String)params.getSslKey())) {
            return this.error("请先填写域名");
        }
        if (params.getType() == 2 && StringUtils.isEmpty((String)params.getSslPem())) {
            return this.error("请先填写域名");
        }
        return this.snServerService.deployDomainSSL(params);
    }

    @RequiresPermissions(value={"system:SnServer:updateUI"})
    @Log(title="更新基础环境UI包", businessType=BusinessType.OTHER)
    @PostMapping(value={"/updateUI"})
    public AjaxResult updateUI(@RequestBody UpdateBaseParams params) {
        if (params.getId() == null) {
            return this.error("服务器ID不能为空");
        }
        return this.snServerService.updateUI(params);
    }

    @RequiresPermissions(value={"system:SnServer:updateBack"})
    @Log(title="更新基础环境后台版本", businessType=BusinessType.OTHER)
    @PostMapping(value={"/updateBack"})
    public AjaxResult updateBack(@RequestBody UpdateBaseParams params) {
        if (params.getId() == null) {
            return this.error("服务器ID不能为空");
        }
        return this.snServerService.updateBack(params);
    }

    @RequiresPermissions(value={"system:SnServer:updateServer"})
    @Log(title="更新基础服务版本", businessType=BusinessType.OTHER)
    @PostMapping(value={"/updateServer"})
    public AjaxResult updateServer(@RequestBody UpdateBaseParams params) {
        if (params.getId() == null) {
            return this.error("服务器ID不能为空");
        }
        if (StringUtils.isEmpty((String)params.getServeName())) {
            return this.error("服务名称不能为空");
        }
        return this.snServerService.updateMessage(params);
    }

    @RequiresPermissions(value={"system:SnServer:ddlUpdate"})
    @Log(title="数据库表结构更新", businessType=BusinessType.OTHER)
    @PostMapping(value={"/ddlUpdate"})
    public AjaxResult ddlUpdate(@RequestBody UpdateBaseParams params) {
        if (params.getId() == null) {
            return this.error("服务器ID不能为空");
        }
        return this.snServerService.DDLUpdate(params.getId());
    }

    @RequiresPermissions(value={"system:SnServer:syncUa"})
    @Log(title="同步爬虫UA库", businessType=BusinessType.OTHER)
    @PostMapping(value={"/syncUa"})
    public AjaxResult syncUa(@RequestBody UpdateBaseParams params) {
        if (params.getId() == null) {
            return this.error("服务器ID不能为空");
        }
        return this.snServerService.syncUa(params.getId());
    }

    @RequiresPermissions(value={"system:SnServer:syncUaAll"})
    @Log(title="同步所有服务器爬虫UA库", businessType=BusinessType.OTHER)
    @PostMapping(value={"/syncUaAll"})
    public AjaxResult syncUaAll() {
        return this.snServerService.syncUaAll(new ArrayList());
    }

    @RequiresPermissions(value={"system:SnServer:getLogs"})
    @PostMapping(value={"/getLogs"})
    public AjaxResult getLogs(@RequestBody DockerLogsParams params) {
        if (params.getId() == null) {
            return this.error("服务器ID不能为空");
        }
        return this.snServerService.getLogs(params);
    }

    @RequiresPermissions(value={"system:SnServer:getConfig"})
    @PostMapping(value={"/getConfig"})
    public AjaxResult getConfig(@RequestBody DockerLogsParams params) {
        if (params.getId() == null) {
            return this.error("服务器ID不能为空");
        }
        SnServer server = this.snServerService.selectSnServerByServerId(params.getId());
        JSONObject data = new JSONObject().fluentPut("ip", (Object)server.getIp()).fluentPut("port", (Object)server.getPort()).fluentPut("userName", (Object)server.getUserName()).fluentPut("password", (Object)server.getDePassword());
        return AjaxResult.success((Object)data);
    }
}

